let thisAppId = 0;
let thisAppName = "";
let niceName = "";
let version = "";

window.onload = function () {
    const listCgi = '/axis-cgi/applications/list.cgi';
    const jsonPath = '../appManifest.json';
    let jsonText;
    let xmlResponse;

    function jsonLoaded (textFile) {
      jsonText = textFile;
      parseJsonResponse(textFile);
      if (xmlResponse) {
        parseXmlResponse(xmlResponse);
      }
    }

    function responseLoaded (response) {
      xmlResponse = response;
      if (jsonText) {
        parseXmlResponse(xmlResponse);
      }
    }

    httpGetAsync(jsonPath, jsonLoaded);
    httpGetAsync(listCgi, responseLoaded);
};

function httpGetAsync(url, callback) {
      let xmlHttp = new XMLHttpRequest();
      xmlHttp.open("GET", url, true);
      xmlHttp.onreadystatechange = function() {
          if (xmlHttp.readyState == XMLHttpRequest.DONE && xmlHttp.status == 200)
            callback(xmlHttp.responseText);
      }
      xmlHttp.send();
}

function parseJsonResponse(json) {
  let jsonObject = JSON.parse(json);
  thisAppId = jsonObject.appId;
  thisAppName = jsonObject.appName;
}

function parseXmlResponse(text) {
  const parser = new DOMParser();
  const xmlDoc = parser.parseFromString(text,"text/xml");
  const nodes = xmlDoc.getElementsByTagName("application");
  let year = (new Date()).getFullYear();

  for (var i=0; i<nodes.length; i++) {
    var appId = nodes[i].getAttribute("ApplicationID");
    var appName = nodes[i].getAttribute("Name");
    if ((appName === thisAppName) && (Number(appId) == thisAppId)) {
      niceName = nodes[i].getAttribute("NiceName");
      version = nodes[i].getAttribute("Version");
      setAboutVariables(niceName, version, year);
      showContent();
    }
  }
}

function setAboutVariables(niceName, version, year) {
  document.getElementById("nice-name").innerHTML = niceName;
  document.getElementById("version").innerHTML = version;
  document.getElementById("year").innerHTML = year;
}

function showContent() {
  document.getElementById("spinner").style.display = "none";
  document.getElementById("aboutContent").style.display = "block";
}
